import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface PreDestroyAnnotationAttributes {
  name?: string[];
}

export class PreDestroyAnnotation extends Annotation {
  public readonly attributes: PreDestroyAnnotationAttributes = {

  };

  public constructor(name: string | string[] | PreDestroyAnnotationAttributes) {
    super();
    if (undefined === name) {
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes.name = [<string>name];
    } else {
      this.copyAttributes(this.attributes, <PreDestroyAnnotationAttributes>name);
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('PreDestroy');
  }

}

export const PreDestroy = Decorator.create(PreDestroyAnnotation);
