import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

import {
  InstanceNameType,
} from '@overflow/commons/di/type';

export interface ResourceAnnotationAttributes {
  name?: InstanceNameType;
}

export class ResourceAnnotation extends Annotation {
  public readonly attributes: ResourceAnnotationAttributes = {
    name: undefined,
  };

  public constructor(name: InstanceNameType | ResourceAnnotationAttributes) {
    super();
    if (undefined === name) {
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes.name = <InstanceNameType>name;
    } else {
      this.copyAttributes(this.attributes, <ResourceAnnotationAttributes>name);
    }
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    console.log('Resource');
  }

  public propertyDecorator(target: Object, propertyKey: PropertyKeyType): void {
    console.log('Resource');
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('Resource');
  }

  public parameterDecorator(target: Object, propertyKey: PropertyKeyType, parameterIndex: number): void {
    console.log('Resource');
  }
}

export const Resource = Decorator.create(ResourceAnnotation);
