import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  TypeUtil,
} from '@overflow/commons/core/type';


export interface ReducerAnnotationAttributes {
  name?: string;
}

export class ReducerAnnotation extends Annotation {
  public readonly attributes: ReducerAnnotationAttributes = {

  };

  public constructor(name: string | ReducerAnnotationAttributes) {
    super();
    if (undefined === name) {
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes.name = <string>name;
    } else {
      this.copyAttributes(this.attributes, <ReducerAnnotationAttributes>name);
    }
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    console.log('Reducer');
  }
}

export const Reducer = Decorator.create(ReducerAnnotation);
